Attribute VB_Name = "Module1"
Option Explicit

Type wInfoX
  Title As String * 40
  hWnd As Long
End Type

Global wInfo() As wInfoX    'array will be redimensioned on demand

'The window messages we'll use in this demo

Global Const WM_KEYDOWN = &H100
Public Const WM_KEYUP = &H101
Public Const WM_CHAR = &H102
Global Const WM_SYSKEYDOWN = &H104
Global Const WM_SETFOCUS = &H7

Global gCPIX_MSG As Long    'holds the CPIX 'command' message
Global gListIndex As Long   'global index iterated by the callback function

Global Const CPIX_CTL_COPY = 1      'CPIX control constant list
Global Const CPIX_CTL_PASTE = 2     'as of 27 October 1998
Global Const CPIX_CTL_AUTORX = 3
Global Const CPIX_CTL_MANRX = 4
Global Const CPIX_CTL_TX = 5
Global Const CPIX_CTL_STBY = 6

Global Const VK_C = &H43

' Declare the API functions.
Declare Function EnumWindows Lib "user32" (ByVal lpEnumFunc As Any, ByVal lParam As Any) As Long
Declare Function GetWindowText Lib "user32" Alias "GetWindowTextA" (ByVal hWnd As Long, ByVal lpString As String, _
ByVal cch As Long) As Long
Declare Function PostMessage Lib "user32" Alias "PostMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Declare Function RegisterWindowMessage Lib "user32" Alias "RegisterWindowMessageA" (ByVal lpString As String) As Long


Sub ScrubWindows()

' Get top-level windows and hWnds, in Z-order order
Dim bRet As Long

ReDim wInfo(0 To 499)   'clear array
Form1.lstOutput.Clear   'clear listbox
gListIndex = 0          'callback will iterate this index

'Set callback address, and let the callback fill in the blanks
bRet = EnumWindows(AddressOf WndEnumProc, Form1.lstOutput)

End Sub


Function WndEnumProc(ByVal hWnd As Long, ByVal lParam As ListBox) As Long

'Callback function for EnumWindows

Dim szTitle As String, O$
Dim bRet As Long

szTitle = String(512, 0)
bRet = GetWindowText(hWnd, szTitle, 512)

' Only show those that have titles.

If (bRet <> 0) Then
 O$ = Left$(szTitle, InStr(szTitle, Chr$(0)) - 1)
 If Len(O$) > 40 Then O$ = Left$(O$, 40)
 wInfo(gListIndex).Title = O$
 O$ = O$ + String$(45 - Len(O$), 32) + Format$(hWnd)
 lParam.AddItem O$
 wInfo(gListIndex).hWnd = hWnd       'store window handle for later use (indexed to caption in list box)
 gListIndex = gListIndex + 1
End If

WndEnumProc = 1             'Must return 1, in order for enumeration to continue.
                            'If you find the window handle you want, return 0 to stop
                            'the cycle.

End Function



