VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "CPIX program controller demo"
   ClientHeight    =   5220
   ClientLeft      =   3135
   ClientTop       =   2385
   ClientWidth     =   7125
   Icon            =   "CPTalk.frx":0000
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   ScaleHeight     =   5220
   ScaleWidth      =   7125
   Begin VB.Timer Timer1 
      Enabled         =   0   'False
      Interval        =   2000
      Left            =   4320
      Top             =   4800
   End
   Begin VB.CheckBox AutoCHK 
      Caption         =   "Auto-Refresh window list"
      Height          =   195
      Left            =   240
      TabIndex        =   17
      Top             =   4860
      Width           =   3375
   End
   Begin VB.Frame Frame2 
      Caption         =   "Select CPIX window to use"
      Height          =   1635
      Left            =   4440
      TabIndex        =   11
      Top             =   3060
      Width           =   2475
      Begin VB.OptionButton CPOpt 
         Caption         =   "CPIX-4"
         Height          =   255
         Index           =   4
         Left            =   120
         TabIndex        =   16
         Top             =   1260
         Width           =   2175
      End
      Begin VB.OptionButton CPOpt 
         Caption         =   "CPIX-3"
         Height          =   255
         Index           =   3
         Left            =   120
         TabIndex        =   15
         Top             =   1020
         Width           =   2175
      End
      Begin VB.OptionButton CPOpt 
         Caption         =   "CPIX-2"
         Height          =   255
         Index           =   2
         Left            =   120
         TabIndex        =   14
         Top             =   780
         Width           =   2175
      End
      Begin VB.OptionButton CPOpt 
         Caption         =   "CPIX-1"
         Height          =   255
         Index           =   1
         Left            =   120
         TabIndex        =   13
         Top             =   540
         Width           =   2175
      End
      Begin VB.OptionButton CPOpt 
         Caption         =   "Active CPIX window"
         Height          =   255
         Index           =   0
         Left            =   120
         TabIndex        =   12
         Top             =   300
         Value           =   -1  'True
         Width           =   2175
      End
   End
   Begin VB.Frame Frame1 
      Caption         =   "Send control message to selected CPIX window ->"
      Height          =   1635
      Left            =   180
      TabIndex        =   3
      Top             =   3060
      Width           =   4155
      Begin VB.CommandButton SendBUT 
         Caption         =   "Send Command"
         Height          =   435
         Left            =   1740
         TabIndex        =   10
         Top             =   960
         Width           =   1935
      End
      Begin VB.OptionButton ctlOpt 
         Caption         =   "Standby"
         Height          =   195
         Index           =   5
         Left            =   1560
         TabIndex        =   9
         Top             =   600
         Width           =   975
      End
      Begin VB.OptionButton ctlOpt 
         Caption         =   "Transmit"
         Height          =   195
         Index           =   4
         Left            =   1560
         TabIndex        =   8
         Top             =   360
         Width           =   975
      End
      Begin VB.OptionButton ctlOpt 
         Caption         =   "Manual RX"
         Height          =   195
         Index           =   3
         Left            =   240
         TabIndex        =   7
         Top             =   1080
         Width           =   1215
      End
      Begin VB.OptionButton ctlOpt 
         Caption         =   "Auto-RX"
         Height          =   195
         Index           =   2
         Left            =   240
         TabIndex        =   6
         Top             =   840
         Width           =   975
      End
      Begin VB.OptionButton ctlOpt 
         Caption         =   "Paste"
         Height          =   195
         Index           =   1
         Left            =   240
         TabIndex        =   5
         Top             =   600
         Value           =   -1  'True
         Width           =   975
      End
      Begin VB.OptionButton ctlOpt 
         Caption         =   "Copy"
         Height          =   195
         Index           =   0
         Left            =   240
         TabIndex        =   4
         Top             =   360
         Width           =   975
      End
   End
   Begin VB.ListBox lstOutput 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   2580
      Left            =   180
      TabIndex        =   0
      Top             =   420
      Width           =   6795
   End
   Begin VB.Label Label2 
      Caption         =   "hWnd"
      Height          =   255
      Left            =   4920
      TabIndex        =   2
      Top             =   120
      Width           =   735
   End
   Begin VB.Label Label1 
      Caption         =   "Top-level windows"
      Height          =   255
      Left            =   240
      TabIndex        =   1
      Top             =   120
      Width           =   2295
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit


Private Sub AutoCHK_Click()

'If selected, re-enumerate every 2 seconds.
'Change Timer1.Interval for others

If AutoCHK.Value = vbChecked Then
  Timer1.Enabled = True
Else
  Timer1.Enabled = False
End If

End Sub

Private Sub Form_Load()

Dim bRet As Long

'Center this window on the desktop
Form1.Top = Screen.Height / 2 - Form1.Height / 2
Form1.Left = Screen.Width / 2 - Form1.Width / 2

'RegisterWindowMessage will either register a new 'command' message
'for CPIX, or return one already registered by CPIX or a different
'controller app.  It all washes the same..

gCPIX_MSG = RegisterWindowMessage("CPIX")

'Enumerate the top-level windows into our UDT array,
'and (just for fun) display all the top-level windows.

ScrubWindows

End Sub


Private Sub SendBUT_Click()
Dim ret As Long, vhWnd As Long, vMsg As Long
Dim L As Long, wParam As Long, cpTitle$

ScrubWindows        're-enumerate windows

For L = 0 To 9      'give callback time to populate array and listbox
  DoEvents
Next L

'Decide which window title string to look for, based on
'the user's selection

If CPOpt(0).Value = True Then cpTitle$ = "CPIX-"     'active window
If CPOpt(1).Value = True Then cpTitle$ = "CPIX-1"
If CPOpt(2).Value = True Then cpTitle$ = "CPIX-2"
If CPOpt(3).Value = True Then cpTitle$ = "CPIX-3"
If CPOpt(4).Value = True Then cpTitle$ = "CPIX-4"

'Iterate through the window list stored in the UDT wInfo(),
'looking for the title.

vhWnd = 0

For L = 0 To 499        '499 is always the depth of the array. (Not likely there are that many windows!)
  If InStr(wInfo(L).Title, cpTitle$) > 0 Then
    vhWnd = wInfo(L).hWnd
    Exit For
  End If
Next L

If vhWnd = 0 Then       'window not found.. gripe!
  MsgBox cpTitle$ + " not found!", vbCritical
  Exit Sub
End If

'Get the command to put in wParam

For L = 0 To 5
  If ctlOpt(L).Value = True Then
    wParam = L + 1  'correspond to CPIX constant index
    Exit For
  End If
Next L

vMsg = gCPIX_MSG    'set the message #
ret = PostMessage(vhWnd, vMsg, wParam, 0)   'send the message (command)

End Sub


Private Sub Timer1_Timer()

ScrubWindows        're-enumerate windows

End Sub


